CREATE DATABASE ChangeDataCapture 
GO

USE ChangeDataCapture
GO

SELECT s.name, t.name 
FROM sys.tables t
JOIN sys.schemas s on t.schema_id = s.schema_id
GO

EXEC sys.sp_cdc_enable_db_change_data_capture
GO

SELECT s.name, t.name 
FROM sys.tables t
JOIN sys.schemas s on t.schema_id = s.schema_id
GO

CREATE TABLE dbo.Note(
	ID int IDENTITY(1,1) NOT NULL PRIMARY KEY,
	NoteDate datetime NOT NULL,
	Author varchar(50) NOT NULL,
	NoteText varchar(max) NOT NULL
) 
GO

EXEC sys.sp_cdc_enable_table_change_data_capture 
@source_schema = 'dbo', 
@source_name = 'Note', 
@role_name = 'cdc_Note'
GO

SELECT s.name, t.name 
FROM sys.tables t
JOIN sys.schemas s on t.schema_id = s.schema_id
GO

INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Bill', 'This is my first note'
GO

SELECT * FROM cdc.dbo_Note_CT
GO

-------------------------------------------------
-- Operation values
-- 1 Delete
-- 2 Insert
-- 3 Update (before)
-- 4 Update (after)
-------------------------------------------------

INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Bill', 'This is my second note'
GO

SELECT * FROM cdc.dbo_Note_CT
GO

INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Bill', 'This is my third note'
GO
UPDATE dbo.Note SET NoteText='I changed the second note to something much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much, much longer' 
WHERE ID=2
GO


DELETE dbo.Note WHERE ID=3
GO



INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Tom', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Tom', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Tom', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Tom', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Tom', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Tom', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Tom', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Tom', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Tom', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Tom', 'Any old note'

INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Sue', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Sue', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Sue', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Sue', 'Any old note'
INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Sue', 'Any old note'


