CREATE DATABASE ChangeTracking
GO
ALTER DATABASE ChangeTracking SET ALLOW_SNAPSHOT_ISOLATION ON
GO

USE ChangeTracking
go
ALTER DATABASE ChangeTracking
SET CHANGE_TRACKING = ON
GO

CREATE TABLE dbo.Note(
	ID int IDENTITY(1,1) NOT NULL PRIMARY KEY,
	NoteDate datetime NOT NULL,
	Author varchar(50) NOT NULL,
	NoteText varchar(max) NOT NULL
) 
GO
ALTER TABLE dbo.Note
ENABLE CHANGE_TRACKING
WITH (TRACK_COLUMNS_UPDATED = ON)
GO


INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Bill', 'This is my first note'
GO

SELECT * FROM CHANGETABLE(CHANGES dbo.Note, 0) CT
GO

INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Bill', 'This is my second note'
GO
UPDATE dbo.Note SET NoteText='I changed the second note' WHERE ID=2
GO

SELECT * FROM CHANGETABLE(CHANGES dbo.Note, 0) CT
GO

INSERT dbo.Note (NoteDate, Author, NoteText) SELECT getdate(), 'Bill', 'This is my third note'
UPDATE dbo.Note SET NoteText='I changed the second note again' WHERE ID=2
UPDATE dbo.Note SET NoteText='I changed the third note' WHERE ID=3
GO

DELETE dbo.Note WHERE ID=3
GO














SELECT * FROM sys.change_tracking_databases
GO
SELECT * FROM sys.change_tracking_tables 
GO

